/*
 File: o2_code_endsym.cpp
 Date and Time: Fri Jan 30 18:55:16 2015 
*/
#include "o2_code_end.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_o2_code_end;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_o2_code_end::TH_o2_code_end(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_o2_code_end;
  NS_o2_code_end::Co2_code_end Co2_code_end_;// parallel-parser's parse table
#define ssPARSE_TABLE Co2_code_end_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_o2_code_end::PROC_TH_o2_code_end(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_o2_code_end";
  static bool one_time(false);
  static NS_o2_code_end::Co2_code_end* NS_o2_code_end_Co2_code_end_(0);// parallel-parser's fsm table
  static Parser* NS_o2_code_end_Co2_code_end_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_o2_code_end_Co2_code_end_ = new NS_o2_code_end::Co2_code_end();// parallel-parser's fsm table
    NS_o2_code_end_Co2_code_end_parser = new Parser(*NS_o2_code_end_Co2_code_end_,Caller_pp);
  }
 proc_parser = NS_o2_code_end_Co2_code_end_parser;
#include "wproc_pp_core.h"
}
void 
Co2_code_end::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Ro2_code_end_:{
       Ro2_code_end* sym;
     if(re->rule_ == 0){
       sym = new Ro2_code_end(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ro2_code_end*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    default: return;
   }
}
